(defsystem #:rails-to-caveman
  :version "0.1.0"
  :author "Craig Oates"
  :license "MIT"
  :depends-on (#:clack
               #:lack
	       #:clack-errors ; <--- Added in Chapter 1.
               #:caveman2
               #:envy
               #:cl-ppcre
               #:uiop
	       #:local-time ; <-- Added Chapter 6
	       #:ratify ; <-- Chapter 7
	       #:trivia ; <-- Chapter 10
	       #:plump  ; <-- Chapter 12.5
	       #:dexador ;<-- Chapter 12.5
	       #:clss

               ;; for @route annotation
               #:cl-syntax-annot

               ;; HTML Template
               #:djula
	       #:3bmd ; for markdown (Ch.9)
	       #:cl-who ; for markup (Ch.9)

               ;; for DB
	       #:mito ; <--- Added in Chapter 4.
               #:datafly
               #:sxql

	       ;; for authentication
	       #:hermetic
	       )
  :components
  ((:module "src"
    :components ((:file "main" :depends-on ("config" "view" "db"))
		 (:file "web" :depends-on ("view" "model" "rfc2616-sec10"))
		 (:file "view" :depends-on ("locale" "config"))
		 (:file "db" :depends-on ("config"))
		 (:file "model" :depends-on ("db" "storage"))
		 (:file "locale" :depends-on ("config")) ; <--- This!
		 (:file "storage") ; Chapter 13
		 (:file "rfc2616-sec10") ; Chapter 12.5 (status-code)
		 ;; (:file "helpers" :depends-on ("rfc2616-sec10")) ; Chapter 12.5
		 (:file "config"))))
  :description "Rails to Caveman2 port."
  :in-order-to ((test-op (test-op "rails-to-caveman-test"))))
